Define CONFIG = 0x0009  'GP3 as input  3  

Symbol gate_out = GP0  '  
Symbol zero_input = GP1  '  
Symbol sens_input = GP2  ' ,   
Symbol mode_in = GP3  '    '   

':

Dim zero_cross As Byte  '   
Dim touch_on As Byte  ' 
Dim touch_off As Byte  '  
Dim power_on As Byte  '  
Dim power_off As Byte  '  
Dim min_power As Byte  ' 
Dim counter_decisecond As Byte  '   
Dim counter_second As Byte  ' 
Dim counter_minute As Byte  ' 
Dim timer_volume As Byte  '   

Const edge_zero = 15  '  
Const gate_on_time = 20  '  
Const max_count = 75  '   
Const count_cycle = 70  '  ,     
Const touch_first = 38  '  ,     
Const touch_second = 40  '  ,       

'/**********   *************/
TRISIO = %1110  '  1     
OPTION_REG = %11010110  'Prescaler Rate 1:128 assigned to Timer0 '      1  128,       0,01   78
'Prescaler Rate 1:128  => 1 000 000 : 100 : 128 = Max count TMR0 = 78

gate_out = 0  ' 

'/*****    *****/
'/   mode_in ,     (    ,  '   /

min_power = 1
If mode_in = 1 Then min_power = 50  '   

'/ * * * * * * * * * * * * * * * * * * * * * * * /

'/**********   *************/
start:

'/**********    0  1 *************/
zero_cross = edge_zero
While zero_cross > 0
If zero_input = 1 Then zero_cross = zero_cross  '1
Wend

Call work_mode()  '/**********   *************/

'/**********    1  0 *************/
zero_cross = edge_zero
While zero_cross > 0
If zero_input = 0 Then zero_cross = zero_cross  '1
Wend

Call work_mode()  '/**********   *************/

Goto start  '/*****     ************/

End  '/**********    *************/ 


'/**********   *************/

Proc work_mode()

TMR0 = 0  '   ()
timer_volume = 0  '  ,    

While timer_volume < max_count  '      ,  

	While timer_volume = TMR0  ',    
	Wend
	
	timer_volume = TMR0  '      ,     ,   

'/********** ,   ,  ,      *************/
	If power_on = 0 Then
		power_off = 0
	Else
		power_off = power_on + 5
	Endif
'/**********    *************/

'/**********     *************/
	If power_on < timer_volume And timer_volume < power_off Then

	High gate_out
	WaitUs gate_on_time
	Low gate_out

	Endif
'/**********    **********/

'/**********       ,   ***********/

	Select Case timer_volume

'/**********   /  *************/
	Case touch_first  'count length touch to on: 0.2-1s, to off > 1s
		zero_cross = GPIO And %00000110
		If zero_cross = %00000010 Then touch_on = touch_on + 1
		If zero_cross = %00000110 Then touch_off = touch_off + 1
'/**********    ***********/

'/**********     / , /  *************/
	Case touch_second
		If touch_off > 20 Then
			If touch_on > 50 And touch_on < 151 Then
			power_on = 0
			Endif
			If touch_on > 10 And touch_on < 51 Then
			power_on = min_power
			Endif
			touch_off = 0
			touch_on = 0
		Endif
'/**********    **********/

'/**********         *************/
	Case count_cycle  'count second & minute
		If power_on = 0 Then
			counter_decisecond = 0
			counter_second = 0
			counter_minute = 0
		Else
			counter_decisecond = counter_decisecond + 1
			If counter_decisecond = 250 Then
				counter_second = counter_second + 1  '2.5 second
				counter_decisecond = 0
				'If counter_second = 6 Then  '15 second ' 
				If counter_second = 240 Then  '10 minute ' 
					counter_minute = counter_minute + 1
					counter_second = 0
				Endif
			Endif
			If counter_minute > 3 Then power_on = min_power
			If counter_minute > 5 Then power_on = 0
		Endif

'/**********     *************/
		If power_on > 1 And counter_minute = 0 Then power_on = power_on
'/**********    **********/

	Case Else
	EndSelect
	
Wend
'/**********            *************/
	
End Proc                                          
'/**********         *************/
